#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>

#define	BUF	(256)

int main(int ac, char *av[], char *env[])
{
  int fd,n,s,pos;
  char buf[BUF];

  if (ac!=3) {
    printf("usage: %s <filename> <content>.\n", av[0]);
    exit(0);
  }
  memcpy(buf, av[2], BUF);
  buf[strlen(av[2])+1]='\0';
/*   memset(buf+strlen(av[2]+1), 0, (BUF-strlen(av[2])-1)); */
  fd=open(av[1], O_WRONLY | O_CREAT);
  printf("fd=%d\n", fd);
  n=write(fd, buf, strlen(av[2])+1);
  printf("n=%d\n", n);
  s=close(fd);
  printf("s=%d\n", s);

  fd=open(av[1], O_RDONLY);
  printf("fd=%d\n", fd);
  pos=lseek(fd, 1, SEEK_SET);
  printf("pos=%d\n", pos);
  n=read(fd, buf, BUF-1);
  printf("buf=\"%s\"(n=%d)\n", buf, n);
  s=close(fd);
  printf("s=%d\n", s);
  
  return 0;
}
