#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int main(int ac, char *av[], char *env[])
{
  pid_t pid;
  int status;

  printf("this is main.(pid=%d)\n", getpid());
  pid=fork();
  if (pid==0) {
    printf("fork() returns %d.  I'm the child.  ", pid);
    printf("my pid is now %d.\n", getpid());
  } else {
    printf("fork() returns %d.  I'm the parent.  ", pid);
    printf("my pid is now %d.\n", getpid());
  }
  pid=waitpid(pid, &status, 0);
  printf("waitpid returns %d.\n", pid);
  return 0;
}
