#include <sys/wait.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

char *str1="child end\n";

int main(int argc, char *argv[])
{
  int pfd[2];
  pid_t cpid;
  char buf;

  assert(argc == 2);

  if (pipe(pfd) == -1) { perror("pipe"); exit(EXIT_FAILURE); }

  cpid = fork();
  if (cpid == -1) { perror("fork"); exit(EXIT_FAILURE); }

  if (cpid == 0) {    /* qvZXpCvǂݍ */
    int i;
    close(pfd[1]);  /* gpȂ write ̓N[Y */

    while (read(pfd[0], &buf, 1) > 0) /* e̓ǂݍ */
      fprintf(stdout, "child: received '%c'\n", buf);

    write(STDOUT_FILENO, str1, strlen(str1));
    close(pfd[0]);

    for (i=0; i<10; i++)
      printf("child:%d\n",i);

    _exit(EXIT_SUCCESS);	/* exit()ł͂Ȃ */

  } else {            /* evZX argv[1] pCv֏ */
    int i;
    close(pfd[0]);  /* gpȂ read ̓N[Y */
    write(pfd[1], argv[1], strlen(argv[1]));
    close(pfd[1]);          /* ǂݍݑ EOF ɏo */
    for (i=0; i<10; i++)
      printf("parent:%d\n",i);
    wait(NULL);             /* qvZX҂ */
    exit(EXIT_SUCCESS);
  }
}
