#include <stdio.h>
#include <stdlib.h>

void move(int n, char *from, char *to)
{
  printf("move %d from %s to %s\n", n, from, to);
}

void hanoi(int n, char *from, char *work, char *to)
{
  if (n>0) {
    hanoi(n-1, from, to, work);
    move (n, from, to);
    hanoi(n-1, work, from, to);
  }
}

int main(int ac, char *av[])
{
  int num=4;

  if (ac==1) {
    printf("usage: %s num\n", av[0]);
    return 1;
  }
  if (ac>=2) num=atoi(av[1]);

  printf("procedures of moving %d disks:\n", num);

  hanoi(num, 'A', 'B', 'C');

  return 0;
}
